<%

'#########################################################################################
' In order to be able to use this script you need to join the merchant program depending on the country where your store is selling the products
'
' AUSTRALIA - http://shopmania.com.au/ (only supporting AUD, NZD datafeeds)
' ARGENTINA - http://www.shopmania.com.ar/ (only supporting ARS, EUR, USD)       *NEW
' BRASIL - http://www.shopmania.com.br/ (only supporting BRL, USD) 
' BULGARY - http://www.shopmania.bg/ (only supporting BGN, EUR, USD)
' CZECH REPUBLIC - http://www.shop-mania.cz/ (only supporting CZK, EUR, USD)		*NEW
' CHILE - http://www.shopmania.cl/ (only supporting CLP, USD, EUR)       *NEW
' CHINA - http://www.shopmania.cn/ (only supporting CNY, USD)       
' DEUTSCHLAND - http://www.shopmania.de/ (only supporting EUR, USD) 
' FRANCE - http://www.shopmania.fr/ (only supporting EUR, USD datafeeds)
' HUNGARY - http://www.shopmania.hu/ (only supporting HUF, EUR, USD datafeeds)
' INDIA - http://www.shopmania.in/ (only supporting INR, USD datafeeds)
' IRELAND - http://www.shopmania.ie/ (only supporting EUR, GBP datafeeds)
' ITALY - http://www.shopmania.it/ (only supporting EUR, USD datafeeds)
' JAPAN - http://www.shopmania.jp/  (only supporting JPY, USD datafeeds)       
' MEXICO - http://www.shopmania.com.mx/ (only supporting MXN (Mexican peso), USD, EUR datafeeds)
' NETHERLANDS - http://www.shopmania.nl/ (only supporting EUR datafeeds)		*NEW
' POLSKA - http://www.shopmania.pl/ (only supporting PLN, EUR, USD) 
' PORTUGAL - http://www.shopmania.pt/ (only supporting EUR, USD) 
' ROMANIA - http://www.shopmania.ro/ (only supporting RON, EUR, USD datafeeds)
' RUSSIA - http://www.shopmania.ru/ (only supporting RUB, EUR, USD)       
' SLOVAKIA - http://www.shop-mania.sk/ (only supporting EUR, USD)       
' SOUTH AFRICA - http://www.shopmania.co.za/ (only supporting ZAR, USD, EUR)       *NEW
' SWEDEN - http://www.shopmania.se/ (only supporting SEK, EUR, USD datafeeds)		*NEW
' SPAIN - http://www.shopmania.es/ (only supporting EUR datafeeds) 
' TURKEY - http://www.shopmania.com.tr/ (only supporting TRY, EUR, USD)
' UK - http://www.shopmania.co.uk/ (only supporting GBP, EUR, USD datafeeds)
' US - http://www.shopmania.com/ (only supporting USD, CAD datafeeds)
'
' Once you join the program and your application is approved you need to place the file on your server and set up the path to the file on the Merchant Interface
' Files will be  retrieved daily from your server having the products listed automatically on ShopMania
'#########################################################################################

' Database access info
dim db_location : db_location = "" 	' Database server map path
dim db_username : db_username = "" 	' Database login username
dim db_password : db_password = "" 	' Database login password
dim con
dim rcs
' Datafeed specific settings
dim datafeed_separator : datafeed_separator  = "|" ' column separator: // Possible options are \t or |
dim datafeed_currency : datafeed_currency = "USD" 'Please make sure that you are using the corect currency code. Possible values are RON, EUR, USD

on error resume next

' Connect to MsAccess database
sub connect()
	set con = Server.CreateObject ("ADODB.Connection")
	dim connection_string : connection_string = "DRIVER={Microsoft Access Driver (*.mdb)};DBQ=" &db_location& ";UID=" &db_username& ";PWD=" &db_password
	con.Open connection_string
	set rcs = Server.CreateObjec ("ADODB.Recordset")
end sub

' Disconnect from MsAccess database
sub disconnect
	on error resume next
	con.Close
	set con = nothing
	on error goto 0
	set rcs = nothing
end sub

' Set table names
dim prod_table : prod_table = "t_prod" ' products table
dim cat_table : cat_table = "t_cat"  ' categories table
dim upload_table : upload_table = "t_upload"  ' product uploads table
dim manuf_table : manuf_table = "t_manufacturer"  ' product manufacturer table

' Define column separator
dim column_separator : column_separator = "|"
if datafeed_separator = "\t" then
	column_separator = vbTab
end if

' Define SQL query to retrive product information.
dim str_query : str_query = "SELECT " _
& prod_table &".prod_ID, " _
& prod_table &".prod_name, "  _
& prod_table &".prod_model, "  _
& prod_table &".prod_desc, "  _
& prod_table &".prod_price "  _
& prod_table &".prod_currency "  _
& manuf_table& ".manuf_name, " _
& cat_table & ".cat_name, " _
& upload_table &".upload_ID, "  _
& " FROM " &prod_table _
& " LEFT JOIN "& manuf_table &" ON "& prod_table &".FK_manuf="& manuf_table &".manuf_ID" _
& " LEFT JOIN "& cat_table &" ON "& prod_table &".FK_cat="& cat_table &".cat_ID" _
& " LEFT JOIN "& upload_table &" ON "& prod_table &".prod_ID="& upload_table &".FK_prod" _
& " WHERE "& prod_table &".prod_active=1"

' Catch unexpected error occured in string query format
if err.number <> 0 then
	Response.Write "Error occured: " & err.Description 
	Response.End 
end if

'Query database for extracting data
connect()
rcs.Open str_query, con

' Catch unexpected error occured while trying to connect and query the database
if err.number <> 0 then
	Response.Write "Error occured in database connection: " & err.Description 
	Response.End 
end if

' Parse returned dataset and retrive product information
if not rcs.EOF then
	rcs.MoveFirst
	while not rcs.EOF
		' Get product name
		dim prod_name : prod_name = function_to_get_product_detail (rcs, "prod_name")
		' Clean product name (strip HTML tags, remove new lines, replace tabs)
		prod_name = function_strip_tags (prod_name)
		prod_name = replace (prod_name, vbCr, "") 	'Carriage Return
		prod_name = replace (prod_name, vbTab, " ") 'Tab Character
		prod_name = replace (prod_name, vbLf, "") 	'Line Feed

		' Get product description
		dim	prod_desc : prodDesc = function_to_get_product_detail (rcs, "prod_desc")
		' Clean product description (strip HTML tags, replace new lines with <BR>, replace tabs)
		prod_desc = function_strip_tags (prod_desc)
		prod_desc = replace (prod_desc, vbCr, "<br>") 
		prod_desc = replace (prod_desc, vbTab, " ")
		prod_desc = replace (prod_desc, vbLf, "")
		
		' Clean product names and descriptions (separators)
		if (datafeed_separator = "\t") then
			prod_name = replace ("\t", " ", function_strip_tags(prod_name))
			prod_desc = replace ("\t", " ", prod_desc)
		else 
			if (datafeed_separator = "|") then
				prod_name = replace ("|", " ", function_strip_tags(prod_name))
				prod_desc = replace ("|", " ", prod_desc)
			else
				Response.Write "Incorrect columns separator."
				Response.End 			
			end if
		end if
		
		' Here you can overwrite the default currency if your products are listed with different currencies
		' datafeed_currency = prod_currency
		
		' Required fields are: category name, merchant, product ID, product name, product URL, product price
		' For the product model you should only use the manufacturer code, ISBN code or UPC code - If you are not sure about a field please leave it empty
		
		' Output the datafeed content
		Response.Write function_to_get_product_detail (rcs, "cat_name") & column_separator _
		& function_to_get_product_detail (rcs, "manuf_name") & column_separator _
		& function_to_get_product_detail (rcs, "prod_model") & column_separator _
		& prod_ID & column_separator _
		& prod_name & column_separator _
		& prod_desc & column_separator _
		& function_to_get_product_url (rcs, "prod_ID") & column_separator _
		& function_to_get_product_image (rcs, "upload_ID") & column_separator _
		& function_to_get_product_detail (rcs, "prod_price") & column_separator _
		& datafeed_currency & column_separator _
		& vbCr
		rcs.MoveNext
	wend
else
	Response.Write "Error: No Data found."
end if

' Disconnect database
disconnect
Response.Write err.Description 

' Function to return the Product URL based on your product ID
function function_to_get_product_url (database_structure, column_name)
	dim product_id : product_id = function_to_get_product_detail (database_structure, column_name)
	function_to_get_product_url = "http://www.example.com/ProductDetails.asp?idproduct=" & product_ID
end function

' Function to return the Product Image based on your product image or optionally Product ID
function function_to_get_product_image (database_structure, column_name)
	dim product_image : product_image = function_to_get_product_detail (database_structure, column_name)
	function_to_get_product_image = "http://www.example.com/ProductImages/" & product_image & ".jpg"
end function

' Get various Product Information
function function_to_get_product_detail (database_structure, column_name)
	on error resume next
	function_to_get_product_detail = function_null_to_str (database_structure (column_name))
	on error goto 0
end function

' OTHER USEFULL FUNCTIONS:

' Convert Null data to empty string
function function_null_to_str (str)
	if isnull (str) or isempty (str) then
		function_null_to_str  = ""
		exit function
	end if
	function_null_to_str = str
end function

' Remove HTML tags from input string
function function_strip_tags (str)
	on error resume next
	replace str, "<", "&lt;"
	replace str, ">", "&gt;"
	function_strip_tags = str
	on error goto 0
end function

on error goto 0

%>